**********************************************************************************
* Filename: B17.sol
* Contents: SWAP 2.0 - Soil hydraulic functions
**********************************************************************************
*c Comment area:                                                    
*c                                                          
*c Parameters based on Staring series (Wosten et al., 1994)                                                          
**********************************************************************************


**********************************************************************************
* Section 1: Method
*
  SWPHYS = 1  ! Switch, method to describe soil hydraulic functions:
*               0 = Table                     
*               1 = Analytical function of Mualem - Van Genuchten (1980)              
**********************************************************************************
                                                                        
**********************************************************************************
* Section 2: Table
*
* Specify pressure head [cm, negative] and hydraulic conductivity [cm/d] as function of
* water content [cm3/cm3];
* start with the lowest water content (corresponding pressure head should be smaller than
* -1.0E6) and use increments of 0.01 until the saturated water content:

* theta  H_theta       K_theta                                        
* End of table                                     
**********************************************************************************
                                                                        
**********************************************************************************
* Section 3: Analytical function of Mualem - Van Genuchten (1980)
*
  COFGEN1 =      0.00 ! Residual moisture content, [0..0.4 cm3/cm3, R]
  COFGEN2 =      0.72 ! Saturated moisture content, [0..0.95 cm3/cm3, R]
  COFGEN3 =      4.46 ! Saturated hydraulic conductivity, [0.01..1000 cm/d, R]
  COFGEN4 =    0.0180 ! Alpha main drying curve drying, [0.0001..1 /cm, R]
  COFGEN5 =    -0.350 ! Exponent in hydraulic conductivity function, [-25..25 -, R]
  COFGEN6 =     1.140 ! Parameter n, [1..5 -, R]
  COFGEN8 =    0.0360 ! Alpha main wetting curve, [0.0001..1 /cm, R]

* End of file ********************************************************************
                                                                        
