** FILE:
**    SWAMAIN.FOR - main program of SWAP
** FILE IDENTIFICATION:
**    $Id: SWAMAIN.FOR 2.5 2000/02/04 16:38:23 Kroes Exp $
** DESCRIPTION:
**    This file contains the program unit SWAP, the main program of SWAP
************************************************************************
      PROGRAM SWAP
C ----------------------------------------------------------------------
C     Date      :4/2/2000
C ----------------------------------------------------------------------
      IMPLICIT NONE
      INCLUDE 'Param.Fi'

      INTEGER   CEXF,BRUNY,BRUND,ERUNY,ERUND,FMAY,NOFRNS,DAYNR
      INTEGER   ICRMOD(0:3,MAYRS),DAYSTA,YEAR,LAYER(MACP)
      INTEGER   BAYRD,BAYRY,RUNNR,THETLO(MAHO),SWSOLU,SWETR,SWNUMS
      INTEGER   SWSCAL,IDEV
      INTEGER   BCRPY(3,MAYRS),BCRPD(3,MAYRS),ECRPY(3,MAYRS)
      INTEGER   ECRPD(3,MAYRS),BSCHY(3,MAYRS),BSCHD(3,MAYRS),CRPNR
      INTEGER   ID,IFINCR,IPORWL,IRMODE,ISEQ,ISTAGE,ISUA,NUMBIT
      INTEGER   NUMLAY,NUMNOD,LOGF,SWHEA,SWSHF,SWDRA,PERIOD,SWRES
      INTEGER   AFO,AUN,ATE,AIR,SWREDU,ISCLAY,SWHYST,SWCF,NOUTDA
      INTEGER   SWVAP,SWDRF,SWSWB,SWAFO,SWAUN,SWATE,SWAIR,SWGC,SWSCRE

      INTEGER   OUTD(1000),OUTY(1000),SWRAI,SWCFBS
      INTEGER   BOTCOM(MAHO),NSCALE,SWMOBI,SWCRACK,SWDIVD,SWINCO

      REAL*8    DZ(MACP),LAI,LAT,KDIF,NRAI,NIRD,RAITIM(100),RAIFLX(100)
      REAL*8    DISNOD(MACP+1),THETOL,ADCRH,ADCRL,ALT,ARFLUX,ATMDEM,CF
      REAL*8    CIRR,PSAND(MAHO),PSILT(MAHO),PCLAY(MAHO),ORGMAT(MAHO)
      REAL*8    DPTRA,DRZ,DT,DTM1,DTMAX,DTMIN,DQROT,DTSOLU,DVS,GIRD,GRAI
      REAL*8    HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,ECMAX,ECSLOP
      REAL*8    PEVA,PTRA,QTOP,RAD,RD,RDM,RDS,RELTR,RH,KDIR,COFAB
      REAL*8    T,TCUM,TAV,TAVD,TM1,TMNR,RDCTB(22),WLS,RSRO,POND,PONDMX
      REAL*8    COFRED,RSIGNI,RSC,GC

      REAL*8    FSCALE(MAYRS),PF1(MAHO),FM1(MAHO),PF2(MAHO),FM2(MAHO)
      REAL*8    SHRINA,MOISR1,THETCR(MAHO)
      REAL*8    MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,COFANI(MAHO)
      REAL*8    GWLI,CFBS
 
      REAL*8    THETA(MACP),H(MACP),THETM1(MACP),HTABLE(MAHO,99),TAU
      REAL*8    COFGEN(8,MAHO),THETAS(MACP),THETAR(MACP),ALFAMG(MACP)

      REAL*8    THETIM(MAHO),HI(MACP)
 
      CHARACTER METFIL*7,STASTR*7,ENVSTR*50
      CHARACTER*8 CRPFIL(3,MAYRS),CAPFIL(3,MAYRS),BBCFIL(MAYRS)
      CHARACTER*8 DRFIL(MAYRS),IRGFIL(MAYRS),CALFIL(MAYRS)
      CHARACTER*8 OUTFIL(MAYRS),SOLFIL(MAHO)
      CHARACTER*8 PRJNAM
      CHARACTER*8 AFONAM,AUNNAM,ATENAM,AIRNAM

      LOGICAL   FLENDD,FLENDR,FLOUT,FLLAST,FL1ST,FLGENU(MAHO),FLRAI
      LOGICAL   FLIRGE,FLIRGS,FLCROP,FLCAL,FLRAIC,FLRDME
C ----------------------------------------------------------------------
C --- INITIALIZATION

C --- write message running to screen
      WRITE (*,'(/,A)') ' Running SWAP ....'

C --- open log file
      CALL Findunit (90,LOGF)
      OPEN (LOGF, FILE = 'SWAP207d.LOG',status='unknown')

      CALL RDKEY (LOGF,PRJNAM,ENVSTR,STASTR,BRUNY,BRUND,ERUNY,
     &  ERUND,ISEQ,FMAY,PERIOD,SWRES,OUTD,OUTY,METFIL,LAT,ALT,SWETR,
     &  SWRAI,IRGFIL,CALFIL,DRFIL,BBCFIL,OUTFIL,NOFRNS,
     &  FLCAL,SWDRA,SWSOLU,SWHEA,SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,
     &  SWAUN,AUNNAM,SWATE,ATENAM,SWAIR,AIRNAM,SWSCRE,NOUTDA)

      CALL RDSWA (PRJNAM,ENVSTR,LOGF,PONDMX,SWREDU,COFRED,RSIGNI,
     &  DTMIN,DTMAX,SWNUMS,THETOL,NUMLAY,NUMNOD,BOTCOM,DZ,SOLFIL,RDS,
     &  SWHYST,TAU,SWSCAL,NSCALE,ISCLAY,FSCALE,SWMOBI,PF1,FM1,PF2,FM2,
     &  THETIM,SWCRACK,SHRINA,MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,
     &  RAPCOEF,DIFDES,SWDIVD,COFANI,SWINCO,HI,GWLI,THETCR,PSAND,PSILT,
     &  PCLAY,ORGMAT,CFBS,SWCFBS)

C --- do simulation run NOFRNS times
      IF (SWSCAL.EQ.1) NOFRNS = NSCALE
      DO 1000 RUNNR = 1,NOFRNS

C --- do Potential part OR Water Limited part of one run
      DO 1000 IPORWL = 1,2

C ---   Initialize timer
        CALL TIMER (1,IPORWL,RUNNR,ISEQ,FMAY,BRUND,BRUNY,BCRPD,
     &  BCRPY,ECRPD,ECRPY,BSCHD,BSCHY,ERUND,ERUNY,IFINCR,DTMAX,
     &  NUMNOD,H,DTMIN,T,TCUM,TM1,DT,DTM1,ID,DAYNR,DAYSTA,YEAR,FLLAST,
     &  FLENDD,FLENDR,FLOUT,FLCROP,CRPNR,ISTAGE,IRMODE,BAYRD,BAYRY,
     &  RAITIM,RAIFLX,FLRAI,ARFLUX,SWSOLU,DTSOLU,SWNUMS,NUMBIT,
     &  THETOL,QTOP,THETA,THETM1,NOFRNS,SWSCAL,FLCAL,CRPFIL,ICRMOD,
     &  CAPFIL,IRGFIL,CALFIL,BBCFIL,DRFIL,OUTFIL,ENVSTR,
     &  WLS,RSRO,SWDRA,POND,PONDMX,PERIOD,SWRES,FLRAIC,FLRDME,LOGF,
     &  OUTD,OUTY,NOUTDA,SWSCRE)

C ---   Initialize soil routine
        IF (IPORWL.EQ.2)
     &  CALL SOIL (1,RUNNR,ISEQ,FLOUT,FL1ST,FLLAST,ENVSTR,
     &  STASTR,OUTFIL(RUNNR),BBCFIL(RUNNR),DRFIL(RUNNR),
     &  BAYRY,BAYRD,DAYNR,ECMAX,ECSLOP,
     &  DAYSTA,YEAR,NUMLAY,NUMNOD,DZ,CIRR,T,TCUM,DT,DRZ,GRAI,GIRD,
     &  PEVA,PTRA,THETA,H,THETM1,TAV,DQROT,DPTRA,ADCRL,ADCRH,ATMDEM,
     &  LAYER,HTABLE,THETLO,DISNOD,NRAI,NIRD,FLGENU,COFGEN,
     &  THETAS,THETAR,ALFAMG,ARFLUX,SWSOLU,DTSOLU,DTMAX,DTMIN,
     &  SWNUMS,NUMBIT,THETOL,QTOP,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,
     &  HLIM4,RDCTB,RDM,BRUNY,ERUNY,BRUND,ERUND,SWHEA,
     &  WLS,RSRO,SWDRA,POND,PONDMX,FLRAIC,AFO,AUN,ATE,AIR,PERIOD,
     &  SWREDU,COFRED,RSIGNI,SWSCAL,ISCLAY,SWHYST,TAU,
     &  SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,SWAUN,AUNNAM,SWATE,ATENAM,
     &  SWAIR,AIRNAM,LOGF,SWSCRE,SWSHF,
     &  PRJNAM,BOTCOM,SOLFIL,PSAND,PSILT,PCLAY,ORGMAT,
     &  FSCALE,SWMOBI,PF1,FM1,PF2,FM2,THETIM,SWCRACK,SHRINA,
     &  MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,SWDIVD,
     &  COFANI,SWINCO,HI,GWLI,FMAY,THETCR,GC,LAI)

C ---   Initialize irrigation routine, part 1
        IF (IPORWL.EQ.2) CALL IRRIG (1,ENVSTR,STASTR,IRGFIL(RUNNR),
     &  OUTFIL(RUNNR),IRMODE,YEAR,DAYNR,RELTR,ID,DVS,FLIRGE,FLIRGS,GIRD,
     &  ISUA,CIRR,NUMNOD,DZ,DRZ,HLIM3L,HLIM3H,HLIM4,LAYER,HTABLE,
     &  THETLO,H,DISNOD,FLGENU,COFGEN,THETAS,THETAR,ALFAMG,
     &  CAPFIL,CRPNR,RUNNR,LOGF,FMAY,BAYRY)

C --- BEGINNING OF A DAY -----------------------------------------------

100     CONTINUE

C ---   Initialize crop routine
        IF (ISTAGE.EQ.2.AND..NOT.FLCROP) THEN
          FLCROP = .TRUE.
          IF (ICRMOD(CRPNR,RUNNR).EQ.1) THEN
             CALL CROPS (1,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,STASTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,TAV,DQROT,PTRA,RELTR,KDIF,KDIR,LAI,
     &      RD,IFINCR,ADCRH,ADCRL,DVS,HLIM1,HLIM2U,HLIM2L,HLIM3H,
     &      HLIM3L,HLIM4,RSC,RDCTB,RDM,ECMAX,ECSLOP,COFAB,LOGF,
     &      SWGC,GC,SWCF,CF,T,IDEV)
          ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.2) THEN 
            CALL CROPD (1,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,STASTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,CF,DVS,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF)
          ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.3) THEN
            CALL GRASS (1,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,STASTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF,CF)
          ENDIF
          DRZ = -RD
C ---     Initialize irrigation routine, part 2
          IF (IPORWL.EQ.2) CALL IRRIG (2,ENVSTR,STASTR,IRGFIL(RUNNR),
     &      OUTFIL(RUNNR),IRMODE,YEAR,DAYNR,RELTR,ID,DVS,FLIRGE,FLIRGS,
     &      GIRD,ISUA,CIRR,NUMNOD,DZ,DRZ,HLIM3L,HLIM3H,HLIM4,LAYER,
     &      HTABLE,THETLO,H,DISNOD,FLGENU,COFGEN,THETAS,THETAR,ALFAMG,
     &      CAPFIL,CRPNR,RUNNR,LOGF,FMAY,BAYRY)
        ELSEIF (ISTAGE.EQ.1) THEN
C ---     set 'nocrop conditions'
          CALL NOCROP (DRZ,LAI,CF,FLCROP)   
        ENDIF

C ---   Irrigation applied or required ?
        IF ((FLIRGE.OR.FLIRGS).AND.IPORWL.EQ.2) THEN
          CALL IRRIG (3,ENVSTR,STASTR,IRGFIL(RUNNR),OUTFIL(RUNNR),
     &    IRMODE,YEAR,DAYNR,RELTR,ID,DVS,FLIRGE,FLIRGS,GIRD,ISUA,CIRR,
     &    NUMNOD,DZ,DRZ,HLIM3L,HLIM3H,HLIM4,LAYER,
     &    HTABLE,THETLO,H,DISNOD,FLGENU,COFGEN,THETAS,THETAR,ALFAMG,
     &    CAPFIL,CRPNR,RUNNR,LOGF,FMAY,BAYRY)
        ELSE
          GIRD = 0.0
          ISUA = 0
        ENDIF

C ---   Intake of weather data
        CALL METEO (T,DT,IPORWL,YEAR,DAYNR,METFIL,ENVSTR,LAT,
     &  ALT,KDIF,KDIR,LAI,GIRD,ISUA,RAD,TAV,TAVD,TMNR,RH,GRAI,NRAI,
     &  NIRD,ATMDEM,PTRA,PEVA,RAITIM,RAIFLX,FLRAI,ARFLUX,CFBS,RSC,
     &  SWETR,ISTAGE,ICRMOD(CRPNR,RUNNR),LOGF,SWSHF,FLRAIC,COFAB,
     &  FLRDME,SWGC,GC,SWRAI,IDEV,SWCF,CF,SWCFBS)
        FL1ST = .TRUE.

C ---   Soil routine for one timestep

        Do while (.not.Flendd)
          IF (IPORWL.EQ.2) THEN
          CALL SOIL (2,RUNNR,ISEQ,FLOUT,FL1ST,FLLAST,ENVSTR,
     &    STASTR,OUTFIL(RUNNR),BBCFIL(RUNNR),DRFIL(RUNNR),
     &    BAYRY,BAYRD,DAYNR,ECMAX,ECSLOP,
     &    DAYSTA,YEAR,NUMLAY,NUMNOD,DZ,CIRR,T,TCUM,DT,DRZ,GRAI,GIRD,
     &    PEVA,PTRA,THETA,H,THETM1,TAV,DQROT,DPTRA,ADCRL,ADCRH,ATMDEM,
     &    LAYER,HTABLE,THETLO,DISNOD,NRAI,NIRD,FLGENU,COFGEN,
     &    THETAS,THETAR,ALFAMG,ARFLUX,SWSOLU,DTSOLU,DTMAX,DTMIN,
     &    SWNUMS,NUMBIT,THETOL,QTOP,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,
     &    HLIM4,RDCTB,RDM,BRUNY,ERUNY,BRUND,ERUND,SWHEA,
     &    WLS,RSRO,SWDRA,POND,PONDMX,FLRAIC,AFO,AUN,ATE,AIR,PERIOD,
     &    SWREDU,COFRED,RSIGNI,SWSCAL,ISCLAY,SWHYST,TAU,
     &    SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,SWAUN,AUNNAM,SWATE,ATENAM,
     &    SWAIR,AIRNAM,LOGF,SWSCRE,SWSHF,
     &    PRJNAM,BOTCOM,SOLFIL,PSAND,PSILT,PCLAY,ORGMAT,
     &    FSCALE,SWMOBI,PF1,FM1,PF2,FM2,THETIM,SWCRACK,SHRINA,
     &    MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,SWDIVD,
     &    COFANI,SWINCO,HI,GWLI,FMAY,THETCR,GC,LAI)
        ENDIF

C ---   Calculation of next timestep & total time
          CALL TIMER (2,IPORWL,RUNNR,ISEQ,FMAY,BRUND,BRUNY,BCRPD,
     &    BCRPY,ECRPD,ECRPY,BSCHD,BSCHY,ERUND,ERUNY,IFINCR,DTMAX,
     &    NUMNOD,H,DTMIN,T,TCUM,TM1,DT,DTM1,ID,DAYNR,DAYSTA,YEAR,FLLAST,
     &    FLENDD,FLENDR,FLOUT,FLCROP,CRPNR,ISTAGE,IRMODE,BAYRD,BAYRY,
     &    RAITIM,RAIFLX,FLRAI,ARFLUX,SWSOLU,DTSOLU,SWNUMS,NUMBIT,
     &    THETOL,QTOP,THETA,THETM1,NOFRNS,SWSCAL,FLCAL,CRPFIL,ICRMOD,
     &    CAPFIL,IRGFIL,CALFIL,BBCFIL,DRFIL,OUTFIL,ENVSTR,
     &    WLS,RSRO,SWDRA,POND,PONDMX,PERIOD,SWRES,FLRAIC,FLRDME,LOGF,
     &    OUTD,OUTY,NOUTDA,SWSCRE)
        EndDo

C ---   Rates of crop growth & integrals of crop growth
        IF (ISTAGE.EQ.2) THEN
          IF (IPORWL.EQ.1)  DQROT = PTRA
          IF (ICRMOD(CRPNR,RUNNR).EQ.1) THEN
            CALL CROPS (2,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,STASTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,TAV,DQROT,PTRA,RELTR,KDIF,KDIR,LAI,
     &      RD,IFINCR,ADCRH,ADCRL,DVS,HLIM1,HLIM2U,HLIM2L,HLIM3H,
     &      HLIM3L,HLIM4,RSC,RDCTB,RDM,ECMAX,ECSLOP,COFAB,LOGF,
     &      SWGC,GC,SWCF,CF,T,IDEV)
         ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.2) THEN 
            CALL CROPD (2,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,STASTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,CF,DVS,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF)
          ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.3) THEN
            CALL GRASS (2,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,STASTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF,CF)
          ENDIF
          DRZ = -RD
C ---     terminal activities irrig
          IF (IFINCR.GT.1.AND.IPORWL.EQ.2) 
     &      CALL IRRIG (4,ENVSTR,STASTR,IRGFIL(RUNNR),OUTFIL(RUNNR),
     &      IRMODE,YEAR,DAYNR,RELTR,ID,DVS,FLIRGE,FLIRGS,GIRD,ISUA,CIRR,
     &      NUMNOD,DZ,DRZ,HLIM3L,HLIM3H,HLIM4,LAYER,
     &      HTABLE,THETLO,H,DISNOD,FLGENU,COFGEN,THETAS,THETAR,ALFAMG,
     &      CAPFIL,CRPNR,RUNNR,LOGF,FMAY,BAYRY)
        ENDIF

C --- END OF A DAY -----------------------------------------------------

C ---   Write output files
        IF (IPORWL.EQ.2)
     &    CALL SOIL (3,RUNNR,ISEQ,FLOUT,FL1ST,FLLAST,ENVSTR,
     &    STASTR,OUTFIL(RUNNR),BBCFIL(RUNNR),DRFIL(RUNNR),
     &    BAYRY,BAYRD,DAYNR,ECMAX,ECSLOP,
     &    DAYSTA,YEAR,NUMLAY,NUMNOD,DZ,CIRR,T,TCUM,DT,DRZ,GRAI,GIRD,
     &    PEVA,PTRA,THETA,H,THETM1,TAV,DQROT,DPTRA,ADCRL,ADCRH,ATMDEM,
     &    LAYER,HTABLE,THETLO,DISNOD,NRAI,NIRD,FLGENU,COFGEN,
     &    THETAS,THETAR,ALFAMG,ARFLUX,SWSOLU,DTSOLU,DTMAX,DTMIN,
     &    SWNUMS,NUMBIT,THETOL,QTOP,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,
     &    HLIM4,RDCTB,RDM,BRUNY,ERUNY,BRUND,ERUND,SWHEA,
     &    WLS,RSRO,SWDRA,POND,PONDMX,FLRAIC,AFO,AUN,ATE,AIR,PERIOD,
     &    SWREDU,COFRED,RSIGNI,SWSCAL,ISCLAY,SWHYST,TAU,
     &    SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,SWAUN,AUNNAM,SWATE,ATENAM,
     &    SWAIR,AIRNAM,LOGF,SWSCRE,SWSHF,
     &    PRJNAM,BOTCOM,SOLFIL,PSAND,PSILT,PCLAY,ORGMAT,
     &    FSCALE,SWMOBI,PF1,FM1,PF2,FM2,THETIM,SWCRACK,SHRINA,
     &    MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,SWDIVD,
     &    COFANI,SWINCO,HI,GWLI,FMAY,THETCR,GC,LAI)

        IF (FLCROP .AND. IPORWL.EQ.2) THEN
          IF (ICRMOD(CRPNR,RUNNR).EQ.1) THEN
            CALL CROPS (3,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,STASTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,TAV,DQROT,PTRA,RELTR,KDIF,KDIR,LAI,
     &      RD,IFINCR,ADCRH,ADCRL,DVS,HLIM1,HLIM2U,HLIM2L,HLIM3H,
     &      HLIM3L,HLIM4,RSC,RDCTB,RDM,ECMAX,ECSLOP,COFAB,LOGF,
     &      SWGC,GC,SWCF,CF,T,IDEV)
         ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.2) THEN 
            CALL CROPD (3,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,STASTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,CF,DVS,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF)
          ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.3) THEN
            CALL GRASS (3,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,STASTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF,CF)
          ENDIF
	  ENDIF

C ---   Update flags, switches and counters
        CALL TIMER (3,IPORWL,RUNNR,ISEQ,FMAY,BRUND,BRUNY,BCRPD,
     &  BCRPY,ECRPD,ECRPY,BSCHD,BSCHY,ERUND,ERUNY,IFINCR,DTMAX,
     &  NUMNOD,H,DTMIN,T,TCUM,TM1,DT,DTM1,ID,DAYNR,DAYSTA,YEAR,FLLAST,
     &  FLENDD,FLENDR,FLOUT,FLCROP,CRPNR,ISTAGE,IRMODE,BAYRD,BAYRY,
     &  RAITIM,RAIFLX,FLRAI,ARFLUX,SWSOLU,DTSOLU,SWNUMS,NUMBIT,
     &  THETOL,QTOP,THETA,THETM1,NOFRNS,SWSCAL,FLCAL,CRPFIL,ICRMOD,
     &  CAPFIL,IRGFIL,CALFIL,BBCFIL,DRFIL,OUTFIL,ENVSTR,
     &  WLS,RSRO,SWDRA,POND,PONDMX,PERIOD,SWRES,FLRAIC,FLRDME,LOGF,
     &  OUTD,OUTY,NOUTDA,SWSCRE)

        IF (.NOT.FLENDR) GOTO 100

C --- END OF A SIMULATION RUN ------------------------------------------

C ---   Terminal activities soil
        IF (IPORWL.EQ.2)
     &  CALL SOIL (4,RUNNR,ISEQ,FLOUT,FL1ST,FLLAST,ENVSTR,
     &  STASTR,OUTFIL(RUNNR),BBCFIL(RUNNR),DRFIL(RUNNR),
     &  BAYRY,BAYRD,DAYNR,ECMAX,ECSLOP,
     &  DAYSTA,YEAR,NUMLAY,NUMNOD,DZ,CIRR,T,TCUM,DT,DRZ,GRAI,GIRD,
     &  PEVA,PTRA,THETA,H,THETM1,TAV,DQROT,DPTRA,ADCRL,ADCRH,ATMDEM,
     &  LAYER,HTABLE,THETLO,DISNOD,NRAI,NIRD,FLGENU,COFGEN,
     &  THETAS,THETAR,ALFAMG,ARFLUX,SWSOLU,DTSOLU,DTMAX,DTMIN,
     &  SWNUMS,NUMBIT,THETOL,QTOP,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,
     &  HLIM4,RDCTB,RDM,BRUNY,ERUNY,BRUND,ERUND,SWHEA,
     &  WLS,RSRO,SWDRA,POND,PONDMX,FLRAIC,AFO,AUN,ATE,AIR,PERIOD,
     &  SWREDU,COFRED,RSIGNI,SWSCAL,ISCLAY,SWHYST,TAU,
     &  SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,SWAUN,AUNNAM,SWATE,ATENAM,
     &  SWAIR,AIRNAM,LOGF,SWSCRE,SWSHF,
     &  PRJNAM,BOTCOM,SOLFIL,PSAND,PSILT,PCLAY,ORGMAT,
     &  FSCALE,SWMOBI,PF1,FM1,PF2,FM2,THETIM,SWCRACK,SHRINA,
     &  MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,SWDIVD,
     &  COFANI,SWINCO,HI,GWLI,FMAY,THETCR,GC,LAI)

1000  CONTINUE

C --- close log file
      CLOSE (LOGF)

C --- close ANIMO output files
      CLOSE (AFO)
      CLOSE (AUN)
      CLOSE (ATE)
      CLOSE (AIR)

C --- create Suc.CEX file for the GUI
      Call  FindUnit (90, CEXF)
      Open  (CEXF, File ='SUC.CEX', status='unknown')
      Close (CEXF)

C --- close log file
      CLOSE (LOGF)
      Print *, 'SWAP 2.07d ready'
      Stop 99
      END

